{$B-,I+,R-,S-,T-,X+}

{(C)98 by CARSTEN WAECHTER aka THE TOXIC AVENGER}
{(C)2006 Game ported by MARKUS TRENKWALDER }

PROGRAM Mean_Bean_Machine_2000;

USES System,Blaster,Vesa,Control,Mode13P,Fli,WinDOS,util;

TYPE   blob = record
               x,y : integer;
               col,ani : word;
              end;
       blob2= record
               col,typ,ani : word;
              end;
       blob3= record
               col,ani,y : word;
               score : string[10];
              end;
       combodat = record
                   typ,ani : word;
                   scorestr: string[10];
                  end;
       comborec = record
                   hits,score : Uint16;
                  end;
       cpudat = record
                 iq,x,rotation : word;
                end;


       game_vars = record
                    mouse1, joy1, joy2 : boolean;
                    mousesens : word;
                    keyb : array[0..3]of word;
                    name : string[5];

                    speed,blobexplode : word;
                    cpuv : cpudat;

                    cpu,outoforder : boolean;

                    left,right,up,down : boolean;

                    score : longint;
                    score2: longint;

                    ytick,rottick,rot,incspeed : word;
                    xtick : integer;

                    blackblobs : word;
                    controljam, gameover : boolean;

                    combo,killed : word;
                    combogfx : combodat;

                    numcol : array[1..6]of word;

                    nextblob : array[1..2]of word;
                    currblob : array[1..2]of blob;
                    blobfeld : array[-1..6,-10..13]of blob2;
                    killfeld : array[0..5,0..12]of blob3;

                    comborecord : comborec;
                    killsrecord : word;
                   end;

       highscoredat = record
                       scorename : array[1..9]of string[5];
                       score : array[1..9]of Uint32;
                       kills : array[1..9]of Uint16;
                       comboname : array[1..9]of string[5];
                       combo : array[1..9]of comborec;
                      end;


CONST  animation : array[0..15,0..31]of byte=(
                   (0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,0,0,0,0,0,0,0,0,0,0,6,7,8,9,8,7,6),
                   (15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,16,16,16,17,17,17,18,18,18),
                   (19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,20,20,20,21,21,21,22,22,22),
                   (27,27,27,27,28,28,28,28,27,27,27,27,27,27,27,27,29,29,29,29,27,27,27,27,27,27,27,27,30,30,30,30),
                   (23,23,23,23,24,24,24,24,23,23,23,23,23,23,23,23,25,25,25,25,23,23,23,23,23,23,23,23,26,26,26,26),
                   (39,39,39,39,39,39,39,39,39,39,39,39,39,39,39,39,39,39,40,40,41,41,42,42,43,43,42,42,41,41,40,40),
                   (10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,12,12,13,13,14,14,13,13,12,12,11,11),
                   (54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,55,55,56,56,57,57,58,58,57,57,56,56,55,55),
                   (49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,50,50,51,51,52,52,53,53,52,52,51,51,50,50),
                   (46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46,46),
                   (44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44),
                   (45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45),
                   (47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47),
                   (48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48),
                   (31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,32,32,33,33,34,34,33,33,32,32),
                   (35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,36,36,37,37,38,38,37,37,36,36));


     blobtyp : array[0..15]of byte=(0,2,1,15,3,7,8,12,4,6,5,13,14,10,11,9);

     maincol : array[1..6]of byte=(28,32,96,144,207,169);

     combostr: array[3..15]of string[8]=('triple','quad','super','hyper','brutal',
                                         'master','awesome','blaster','monster',
                                         'king','killer','ultra','ultimate');


VAR  cd_ok, joy1_ok, joy2_ok, mouse_ok, sb_ok : boolean;

     fpscounter,fpscounter2 : word;
     fps : string[3];

     vscr,vscr2 : pointer;

     fonts : array[0..3,0..47]of linsprite;  { 0=BIG font, 1=SMALL, 2=DIGI, 3=TITLE }

     blobs : array[1..6,0..58]of linsprite;  { 1=Black, 2=Red, 3=Green, 4=Blue, 5=Brown, 6=Pink }

     combos: array[0..8]of linsprite;        { Breaker, Combo, Double, Triple, Quad, Super, Hyper, Brutal, Master }

     fight : array[0..1]of linsprite;
     winlos: array[0..1]of linsprite;

     fire  : array[1..4]of linsprite;
     border: array[1..2]of linsprite;

     flic : array[0..9]of pointer;
     flicani : word;

     infostr : array[0..4]of string[18];
     infoani : word;
     gamev   : array[1..2]of game_vars;

     spr2000,sprshade : linsprite;
     sprptr : array[0..1]of linsprite;

     palette2: array[0..767]of byte;

     waves   : array[0..19]of wave_data;

     global,global2 : integer;

     paused,paused2,exitgame : boolean;

     highscore : highscoredat;


{----------------------------------------------------------------------------}

procedure fadeproc;
begin
  inc(global,2);
end;

procedure fadeout(var pal : array of Uint8);
var v : Integer;
begin
  global := 0;
  @timerrelatedproc := @fadeproc;
  calltimerrelatedproc := true;
 
  v := 0;
  repeat
	UpdateLoop;
	while global > v do begin
		decpalette(2,@pal);
		inc(v);
	end;
  until global >= 128;
  
  calltimerrelatedproc := false;
end;

procedure fadein(const pal1 : array of Uint8; var pal2 : array of Uint8);
var v,v2 : integer;
begin
  global := 0;
  @timerrelatedproc:=@fadeproc;
  calltimerrelatedproc:=true;
  
  v := 0;
  repeat
	UpdateLoop;
	while global > v do begin
		for v2 := 0 to 767 do begin
			if (pal1[v2]>pal2[v2]) then inc(pal2[v2]);
			if (pal1[v2]>pal2[v2]) then inc(pal2[v2]);
		end;
		setpalette(@pal2);
		inc(v);
	end;
  until global >= 128;
  
  calltimerrelatedproc := false;
end;

PROCEDURE Outta_Here(pic : boolean);
 Var v,v2 : word;
BEGIN

  if pic then begin
   
  filld(vscr,64000,0);
  copyscreen100(vscr);

   pcx_2_mem(vscr,'data/mbm2000.p17',true);
   fillchar(palette2,768,0);
   setpalette(@palette2);
   copyscreen100(vscr);
   putchannel(waves[19],30,4);

   fadein(palette, palette2);

   repeat
     UpdateLoop;
   until not keypressed;
   repeat
     UpdateLoop;
   until keypressed;

   fadeout(palette2);
   
  end;

  if sb_ok then DoneSB else DoneNoSB;

END;


PROCEDURE Init_MBM;
 Var v,v2 : word;
     f : file;
BEGIN

   vscr :=globalallocptr(0,4 * 64000);
   vscr2:=globalallocptr(0,4 * 64000);
  
  pcx_2_mem(vscr,'data/mbm2000.p00',false);
  for v:=0 to 10 do
   getsprite13(vscr,v*11+26560,12,19,fonts[2,v]); { DIGI, BIG, SMALL, BLACK GUYS }
  for v2:=0 to 2 do
   for v:=0 to 15 do
    getsprite13(vscr,v*20+321+v2*17*320,19,16,fonts[0,v+v2*16]);
  for v2:=0 to 1 do
   for v:=0 to 23 do
    getsprite13(vscr,v*13+17601+v2*14*320,12,13,fonts[1,v+v2*24]);
  for v:=0 to 5 do
   getsprite13(vscr,v*34+33281,33,28,blobs[1,v]);
  for v:=0 to 3 do
   getsprite13(vscr,v*34+42561,33,28,blobs[1,v+6]);

  getsprite13(vscr,51840,199,18,fire[1]);
  mirrorsprite13(fire[1],fire[2]);
  getsprite13(vscr,58240,199,18,border[1]);
  mirrorsprite13(border[1],border[2]);

  pcx_2_mem(vscr,'data/mbm2000.p01',false);           { TITLE-FONT }

  for v2:=0 to 4 do
   for v:=0 to 4 do
    getsprite13(vscr,v*56+v2*37*320+324,49,36,fonts[3,v+v2*5]);

  spr2000.adr:=globalallocptr(0,306*70);
  spr2000.dtx:=306;
  spr2000.dty:=70;
  pcx_2_mem(spr2000.adr,'data/mbm2000.p02',false);

  pcx_2_mem(vscr,'data/mbm2000.p03',false);

  for v2:=0 to 3 do
   for v:=0 to 4 do
    getsprite13(vscr,v*56+v2*37*320+324,49,36,fonts[3,v+v2*5+25]);
  for v:=0 to 2 do
   getsprite13(vscr,v*56+47684,49,36,fonts[3,v+45]);
  getsprite13(vscr,47849,150,50,sprshade);
  getsprite13(vscr,60167,22,9,sprptr[0]);
  mirrorsprite13(sprptr[0],sprptr[1]);

  pcx_2_mem(vscr,'data/mbm2000.p04',false);
  for v:=0 to 5 do
   getsprite13(vscr,v*34+321,33,28,blobs[2,v]);
  for v:=0 to 8 do
   getsprite13(vscr,v*34+9601,33,28,blobs[2,v+6]);
  for v2:=0 to 2 do
   for v:=0 to 7 do
    getsprite13(vscr,v*34+18881+v2*29*320,33,28,blobs[2,v+v2*8+15]);
  for v:=0 to 6 do
   getsprite13(vscr,v*34+46721,33,28,blobs[2,v+39]);
  for v:=0 to 2 do
   getsprite13(vscr,(v+6)*34+321,33,28,blobs[2,v+46]);

  pcx_2_mem(vscr,'data/mbm2000.p05',false);
  for v:=0 to 5 do
   getsprite13(vscr,v*34+321,33,28,blobs[3,v]);
  for v:=0 to 8 do
   getsprite13(vscr,v*34+9601,33,28,blobs[3,v+6]);
  for v2:=0 to 2 do
   for v:=0 to 7 do
    getsprite13(vscr,v*34+18881+v2*29*320,33,28,blobs[3,v+v2*8+15]);
  for v:=0 to 6 do
   getsprite13(vscr,v*34+46721,33,28,blobs[3,v+39]);
  for v:=0 to 2 do
   getsprite13(vscr,(v+6)*34+321,33,28,blobs[3,v+46]);

  pcx_2_mem(vscr,'data/mbm2000.p06',false);
  for v:=0 to 5 do
   getsprite13(vscr,v*34+321,33,28,blobs[4,v]);
  for v:=0 to 8 do
   getsprite13(vscr,v*34+9601,33,28,blobs[4,v+6]);
  for v2:=0 to 2 do
   for v:=0 to 7 do
    getsprite13(vscr,v*34+18881+v2*29*320,33,28,blobs[4,v+v2*8+15]);
  for v:=0 to 6 do
   getsprite13(vscr,v*34+46721,33,28,blobs[4,v+39]);
  for v:=0 to 2 do
   getsprite13(vscr,(v+6)*34+321,33,28,blobs[4,v+46]);

  pcx_2_mem(vscr,'data/mbm2000.p07',false);
  for v:=0 to 5 do
   getsprite13(vscr,v*34+321,33,28,blobs[5,v]);
  for v:=0 to 8 do
   getsprite13(vscr,v*34+9601,33,28,blobs[5,v+6]);
  for v2:=0 to 2 do
   for v:=0 to 7 do
    getsprite13(vscr,v*34+18881+v2*29*320,33,28,blobs[5,v+v2*8+15]);
  for v:=0 to 6 do
   getsprite13(vscr,v*34+46721,33,28,blobs[5,v+39]);
  for v:=0 to 2 do
   getsprite13(vscr,(v+6)*34+321,33,28,blobs[5,v+46]);

  pcx_2_mem(vscr,'data/mbm2000.p08',false);
  for v:=0 to 5 do
   getsprite13(vscr,v*34+321,33,28,blobs[6,v]);
  for v:=0 to 8 do
   getsprite13(vscr,v*34+9601,33,28,blobs[6,v+6]);
  for v2:=0 to 2 do
   for v:=0 to 7 do
    getsprite13(vscr,v*34+18881+v2*29*320,33,28,blobs[6,v+v2*8+15]);
  for v:=0 to 6 do
   getsprite13(vscr,v*34+46721,33,28,blobs[6,v+39]);
  for v:=0 to 2 do
   getsprite13(vscr,(v+6)*34+321,33,28,blobs[6,v+46]);

  pcx_2_mem(vscr,'data/mbm2000.p09',false);
  for v2:=0 to 1 do
   for v:=0 to 4 do
    getsprite13(vscr,v*34+321+v2*29*320,33,28,blobs[4,v+v2*5+49]);
  for v2:=0 to 1 do
   for v:=0 to 4 do
    getsprite13(vscr,v*34+18881+v2*29*320,33,28,blobs[3,v+v2*5+49]);
  for v2:=0 to 1 do
   for v:=0 to 4 do
    getsprite13(vscr,v*34+37441+v2*29*320,33,28,blobs[2,v+v2*5+49]);
  for v:=0 to 3 do
   getsprite13(vscr,(v+5)*34+321,33,28,blobs[5,v+49]);
  for v:=0 to 3 do
   getsprite13(vscr,(v+5)*34+9601,33,28,blobs[5,v+54]);
  getsprite13(vscr,19051,33,28,blobs[5,53]);
  getsprite13(vscr,28331,33,28,blobs[5,58]);
  for v:=0 to 3 do
   getsprite13(vscr,(v+5)*34+37441,33,28,blobs[6,v+49]);
  for v:=0 to 3 do
   getsprite13(vscr,(v+5)*34+46721,33,28,blobs[6,v+54]);
  getsprite13(vscr,19085,33,28,blobs[6,53]);
  getsprite13(vscr,28365,33,28,blobs[6,58]);

  pcx_2_mem(vscr,'data/mbm2000.p10',false);
  getsprite13(vscr,49962,236,40,combos[1]);
  getsprite13(vscr,35564,235,41,combos[8]);
  getsprite13(vscr,19563,237,40,combos[7]);
  getsprite13(vscr,3580,200,41,combos[6]);

  pcx_2_mem(vscr,'data/mbm2000.p11',false);
  getsprite13(vscr,1307,230,34,combos[2]);
  getsprite13(vscr,16382,210,40,combos[3]);
  getsprite13(vscr,30083,169,40,combos[4]);
  getsprite13(vscr,49657,199,41,combos[5]);

  combos[0].adr:=globalallocptr(0,200*50);
  pcx_2_mem(combos[0].adr,'data/mbm2000.p12',false);
  combos[0].dtx:=200;
  combos[0].dty:=50;

  fight[0].adr:=globalallocptr(0,274*110);
  pcx_2_mem(fight[0].adr,'data/mbm2000.p13',false);
  fight[0].dtx:=274;
  fight[0].dty:=110;

  fight[1].adr:=globalallocptr(0,274*110);
  pcx_2_mem(fight[1].adr,'data/mbm2000.p14',false);
  fight[1].dtx:=274;
  fight[1].dty:=110;

  fire[3].adr:=globalallocptr(0,14*374);
  pcx_2_mem(fire[3].adr,'data/mbm2000.p15',false);
  fire[3].dtx:=14;
  fire[3].dty:=374;
  mirrorsprite13(fire[3],fire[4]);

  pcx_2_mem(vscr,'data/mbm2000.p16',false);
  getsprite13(vscr,8005,312,49,winlos[0]);
  getsprite13(vscr,25925,310,52,winlos[1]);

  case random(3) of
   0 : fli_2_mem(flic,'data/mbm2000.f00',false,v);
   1 : fli_2_mem(flic,'data/mbm2000.f01',false,v);
   2 : fli_2_mem(flic,'data/mbm2000.f02',false,v);
  end;
  
  if sb_ok then begin
   readwave('data/mbm2000.w00',waves[0]);
   readwave('data/mbm2000.w01',waves[1]);
   readwave('data/mbm2000.w02',waves[2]);
   readwave('data/mbm2000.w03',waves[3]);

   readwave('data/mbm2000.w04',waves[4]);
   readwave('data/mbm2000.w05',waves[5]);
   readwave('data/mbm2000.w06',waves[6]);
   readwave('data/mbm2000.w07',waves[7]);
   readwave('data/mbm2000.w08',waves[8]);
   readwave('data/mbm2000.w09',waves[9]);
   readwave('data/mbm2000.w10',waves[10]);

   readwave('data/mbm2000.w11',waves[11]);
   readwave('data/mbm2000.w12',waves[12]);
   readwave('data/mbm2000.w13',waves[13]);
   readwave('data/mbm2000.w14',waves[14]);
   readwave('data/mbm2000.w15',waves[15]);
   readwave('data/mbm2000.w16',waves[16]);
   readwave('data/mbm2000.w17',waves[17]);
   readwave('data/mbm2000.w18',waves[18]);
   readwave('data/mbm2000.w19',waves[19]);
  end;


  assign(f,'data/mbm2000.cfg');
  reset(f,1);
  blockread(f,gamev[1],Ofs(gamev[1].cpuv.x) - Ofs(gamev[1].mouse1));
  blockread(f,gamev[2],Ofs(gamev[2].cpuv.x) - Ofs(gamev[2].mouse1));
  close(f);

  assign(f,'data/mbm2000.hig');
  reset(f,1);
  blockread(f,highscore,sizeof(highscore));
  close(f);
  
  repeat
    UpdateLoop;
  until not keypressed;

END;


PROCEDURE Startup_Screen;
 Var v : word;
BEGIN

  sb_ok:=false;
  cd_ok:=false; joy1_ok:=false;
  joy2_ok:=false; mouse_ok:=false;

  if not initvesa then begin
    halt(0);
  end;
  
  v:=initmouse;
  if (v<>0) then begin mouse_ok:=true; end;

{ No Joystick support for now }
(* 
  if joystick1_installed then begin
   joy1_ok:=true; joystick_status(true,false);
   with joy_config do begin
    xnorm1:=joy.x1; ynorm1:=joy.y1; xmin1:=$ffff; ymin1:=$ffff; xmax1:=0; ymax1:=0;
   end;
   repeat
    joystick_status(true,false);
    with joy_config do begin
     if (joy.x1>xmax1) then xmax1:=joy.x1;
     if (joy.x1<xmin1) then xmin1:=joy.x1;
     if (joy.y1>ymax1) then ymax1:=joy.y1;
     if (joy.y1<ymin1) then ymin1:=joy.y1;
    end;
    if keys[1] then joy1_ok:=false;
   until (joy.b1) or (joy.b2) or keys[1];
  end;
  repeat
  until not keys[1];
  if joystick2_installed then begin
   joy2_ok:=true; joystick_status(false,true);
   with joy_config do begin
    xnorm2:=joy.x2; ynorm2:=joy.y2; xmin2:=$ffff; ymin2:=$ffff; xmax2:=0; ymax2:=0;
   end;
   repeat
    joystick_status(false,true);
    with joy_config do begin
     if (joy.x2>xmax2) then xmax2:=joy.x2;
     if (joy.x2<xmin2) then xmin2:=joy.x2;
     if (joy.y2>ymax2) then ymax2:=joy.y2;
     if (joy.y2<ymin2) then ymin2:=joy.y2;
    end;
    if keys[1] then joy2_ok:=false;
   until (joy.b3) or (joy.b4) or keys[1];
  end;
*)

  if reset_sb then 
    sb_ok := initsb(8);

END;


{----------------------------------------------------------------------------}


PROCEDURE TimerIntro;
BEGIN

  dec(global,4);

END;

PROCEDURE TimerIntro2;
BEGIN

  inc(global,2);

END;

PROCEDURE Intro_MBM;
 Var v,v2 : word;
     jaguar,toxie : linsprite;
     ainc : array [0 .. 3] of linsprite;
BEGIN


  if fakemode100 then initvesamode($101) else initvesamode($100);
  jaguar.adr:=globalallocptr(0,430*152);
  jaguar.dtx:=430;
  jaguar.dty:=152;
  pcx_2_mem(jaguar.adr,'data/mbm2000.p18',true);
  
  putchannel(waves[16],30,1);
  global:=-50;
  @timerrelatedproc:=@timerintro2;
  calltimerrelatedproc:=true;

  repeat
    UpdateLoop;
   
    filld(vscr,64000,0);

    case global of
      0..99 : putscalsprt100(vscr,320,200,global,global,jaguar);
      100..500 : putsprt100(vscr,320,200,jaguar);
      501..600 : putscalsprt100(vscr,320,200,600-global,600-global,jaguar);
    end;
   
    waitretrace;
    copyscreen100(vscr);

  until keypressed or (global>650);

  calltimerrelatedproc:=false;

  globalfreeptr(jaguar.adr);

  repeat
	UpdateLoop;
  until not keypressed;
  
  filld(vscr2,64000,0);
  copyscreen100(vscr2);

  if (random(2)=0) then pcx_2_mem(vscr,'data/mbm2000.p19',true)
   else pcx_2_mem(vscr,'data/mbm2000.p20',true);
   
  for v:=0 to 3 do begin
   ainc[v].adr:=PUint8(vscr) + v * 64000;
   ainc[v].dtx:=640;
   ainc[v].dty:=100;
  end;
  
  putchannel(waves[17],30,2);
  global:=0;
  @timerrelatedproc:=@timerintro;
  calltimerrelatedproc:=true;
  
  repeat
	UpdateLoop;

   if (global>-320) then begin
    putsolidsprt100(vscr2,global shl 1+960,50,ainc[0]);
    putsolidsprt100(vscr2,-320-global shl 1,150,ainc[1]);
    putsolidsprt100(vscr2,global shl 1+960,250,ainc[2]);
    putsolidsprt100(vscr2,-320-global shl 1,350,ainc[3]);

    waitretrace;
    copyscreen100(vscr2);
   end else copyscreen100(vscr);

  until keypressed or (global<-1200);
  
  calltimerrelatedproc:=false;

  repeat
	UpdateLoop;
  until not keypressed;
  
  fadeout(palette);
  
  filld(vscr,64000,0);
  copyscreen100(vscr);

  toxie.adr:=globalallocptr(0,212*307);
  toxie.dtx:=212;
  toxie.dty:=307;
  pcx_2_mem(toxie.adr,'data/mbm2000.p21',true);
  putsolidsprt100(vscr,320,200,toxie);
  fillchar(palette2,768,0);
  setpalette(@palette2);
  copyscreen100(vscr);
  putchannel(waves[19],30,1);

  fadein(palette, palette2);
  
  calltimerrelatedproc := true;
  @timerrelatedproc := @timerintro2;
  repeat
    UpdateLoop;
  until keypressed or (global>550);
  calltimerrelatedproc := false;
  
  globalfreeptr(toxie.adr);

  repeat
    UpdateLoop;
  until not keypressed;

  fadeout(palette2);
  
  calltimerrelatedproc := false;
  
END;


{----------------------------------------------------------------------------}


PROCEDURE WriteStr(dest : pointer;bla : string;x,y : integer;num : word);
 Var v,dtx : word;
BEGIN

  case num of
   0..1,3 : begin
             dtx:=fonts[num,0].dtx-2;
             dec(x,(length(bla)+1)*dtx shr 1);
             for v:=1 to length(bla) do
              case bla[v] of
               'a'..'z' : putsprt100(dest,x+v*dtx,y,fonts[num,ord(bla[v])-97]);
               'A'..'Z' : putsprt100(dest,x+v*dtx,y,fonts[num,ord(bla[v])-65]);
               '0'..'9' : putsprt100(dest,x+v*dtx,y,fonts[num,ord(bla[v])-22]);
               '!' : putsprt100(dest,x+v*dtx,y,fonts[num,36]);
               ''''..'/': putsprt100(dest,x+v*dtx,y,fonts[num,ord(bla[v])-2]);
               ':' : putsprt100(dest,x+v*dtx,y,fonts[num,46]);
               '?' : putsprt100(dest,x+v*dtx,y,fonts[num,47]);
              end;
            end;
   2 : begin
        dtx:=fonts[2,0].dtx-1;
        dec(x,(length(bla)+1)*dtx shr 1);
        for v:=1 to length(bla) do
         if bla[v] in ['0'..'9'] then putsprt100(dest,x+v*dtx,y,fonts[2,ord(bla[v])-48])
          else putsprt100(dest,x+v*dtx,y,fonts[2,10]);
       end;
   4 : begin
        dtx:=fonts[3,0].dtx shr 1-2;
        dec(x,(length(bla)+1)*dtx shr 1);
        for v:=1 to length(bla) do
         case bla[v] of
          'a'..'z' : putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,ord(bla[v])-97]);
          'A'..'Z' : putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,ord(bla[v])-65]);
          '0'..'9' : putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,ord(bla[v])-22]);
          '!' : putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,36]);
          ''''..'/': putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,ord(bla[v])-2]);
          ':' : putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,46]);
          '?' : putscalsprt100(dest,x+v*dtx,y,50,50,fonts[3,47]);
         end;
       end;
  end;

END;


PROCEDURE CreditsHelp(c : boolean);
 Const credits : array[0..17]of string[30]=('.. the credits ..',
                                           ' ',
                                           '.. all the coding/design ..',
                                           '* the toxic avenger *',
                                           ' ',
                                           '.. beta testing ..',
                                           '* c+c connection * simon *',
                                           '* stief * fred * tim *',
                                           '* and all i forgot *',
                                           ' ',
                                           '.. greetings ..',
                                           '* yak(llamasoft) - tempest/  ',
                                           '   defender 2000 rulez !!!  *',
                                           '* idsoft * the co-existence *',
                                           '* future crew * alpha helix *',
                                           '* legenddesign * dust * dsd *',
                                           '* midway * capcom * factor5 *',
                                           '* rare * atari teenage riot *');
      help    : array[0..17]of string[30]=('.. help ..',
                                           ' ',
                                           'the gameplay of mbm 2000 is',
                                           'pretty easy .. 2 beans are',
                                           'falling down the screen ..',
                                           'its your job to group same',
                                           'colors .. if more then 3 of',
                                           'them are linked they will',
                                           'explode .. thats all !!',
                                           ' ',
                                           'in a 2 player game exploding',
                                           'beans morph into black beans',
                                           'which drop down in the other',
                                           'field .. the problem is',
                                           'that you cannot link black',
                                           'beans with each other ..',
                                           ' ',
                                           '.. now blast some beans ..');
 Var v : word;
BEGIN

  
  moved(vscr2,vscr,64000);
  if c then
   for v:=0 to 17 do
    writestr(vscr,credits[v],320,v*22+13,4)
  else for v:=0 to 17 do
    writestr(vscr,help[v],320,v*22+13,4);
  copyscreen100(vscr);

  repeat
   UpdateLoop;
  until not keypressed;
  repeat
   UpdateLoop;
  until keypressed;

  putchannel(waves[18],20,1);

  fadeout(palette);

END;


PROCEDURE TimerTitle2;
BEGIN

  if (global2 mod 7=0) and not paused and not paused2 then begin
   if keys[$48] and (global>0) then begin dec(global); putchannel(waves[13],20,1); end;
   if keys[$50] and (global<13) then begin inc(global); putchannel(waves[13],20,1); end;
   if keys[$1c] or keys[$39] then case global of
    2,9 : begin paused:=true; putchannel(waves[18],20,1); end;
    5,12: begin paused2:=true; putchannel(waves[18],20,1); end;
   end;
   if keys[$4b] then begin
    case global of
     0 : if (gamev[1].speed>1) then begin dec(gamev[1].speed); putchannel(waves[14],30,1); end;
     1 : if (gamev[1].blobexplode>3) then begin dec(gamev[1].blobexplode); putchannel(waves[14],30,1); end;
     3 : if (gamev[1].cpuv.iq>1) then begin dec(gamev[1].cpuv.iq); putchannel(waves[14],30,1); end;
     4 : begin
          putchannel(waves[14],30,1);
          if gamev[1].joy1 or gamev[1].joy2 or gamev[1].mouse1 then begin
           if gamev[1].joy1 then begin gamev[1].joy1:=false; gamev[1].joy2:=true; end
            else if gamev[1].joy2 then begin gamev[1].joy2:=false; gamev[1].mouse1:=true; end
             else if gamev[1].mouse1 then gamev[1].mouse1:=false;
          end else gamev[1].joy1:=true;
         end;
     6 : if (gamev[1].mousesens>5) then begin dec(gamev[1].mousesens); putchannel(waves[14],30,1); end;
     7 : if (gamev[2].speed>1) then begin dec(gamev[2].speed); putchannel(waves[14],30,1); end;
     8 : if (gamev[2].blobexplode>3) then begin dec(gamev[2].blobexplode); putchannel(waves[14],30,1); end;
     10: if (gamev[2].cpuv.iq>1) then begin dec(gamev[2].cpuv.iq); putchannel(waves[14],30,1); end;
     11: begin
          putchannel(waves[14],30,1);
          if gamev[2].joy1 or gamev[2].joy2 or gamev[2].mouse1 then begin
           if gamev[2].joy1 then begin gamev[2].joy1:=false; gamev[2].joy2:=true; end
            else if gamev[2].joy2 then begin gamev[2].joy2:=false; gamev[2].mouse1:=true; end
             else if gamev[2].mouse1 then gamev[2].mouse1:=false;
          end else gamev[2].joy1:=true;
         end;
     13: if (gamev[2].mousesens>5) then begin dec(gamev[2].mousesens); putchannel(waves[14],30,1); end;
    end;
   end;
   if keys[$4d] then begin
    case global of
     0 : if (gamev[1].speed<2) then begin inc(gamev[1].speed); putchannel(waves[14],30,1); end;
     1 : if (gamev[1].blobexplode<99) then begin inc(gamev[1].blobexplode); putchannel(waves[14],30,1); end;
     3 : if (gamev[1].cpuv.iq<5) then begin inc(gamev[1].cpuv.iq); putchannel(waves[14],30,1); end;
     4 : begin
          putchannel(waves[14],30,1);
          if gamev[1].joy1 or gamev[1].joy2 or gamev[1].mouse1 then begin
           if gamev[1].mouse1 then begin gamev[1].mouse1:=false; gamev[1].joy2:=true; end
            else if gamev[1].joy2 then begin gamev[1].joy2:=false; gamev[1].joy1:=true; end
             else if gamev[1].joy1 then gamev[1].joy1:=false;
          end else gamev[1].mouse1:=true;
         end;
     6 : if (gamev[1].mousesens<99) then begin inc(gamev[1].mousesens); putchannel(waves[14],30,1); end;
     7 : if (gamev[2].speed<2) then begin inc(gamev[2].speed); putchannel(waves[14],30,1); end;
     8 : if (gamev[2].blobexplode<99) then begin inc(gamev[2].blobexplode); putchannel(waves[14],30,1); end;
     10: if (gamev[2].cpuv.iq<5) then begin inc(gamev[2].cpuv.iq); putchannel(waves[14],30,1); end;
     11: begin
          putchannel(waves[14],30,1);
          if gamev[2].joy1 or gamev[2].joy2 or gamev[2].mouse1 then begin
           if gamev[2].mouse1 then begin gamev[2].mouse1:=false; gamev[2].joy2:=true; end
            else if gamev[2].joy2 then begin gamev[2].joy2:=false; gamev[2].joy1:=true; end
             else if gamev[2].joy1 then gamev[2].joy1:=false;
          end else gamev[2].mouse1:=true;
         end;
     13: if (gamev[2].mousesens<99) then begin inc(gamev[2].mousesens); putchannel(waves[14],30,1); end;
    end;
   end;
  end;

  if (global2<139) then inc(global2) else global2:=0;

END;

PROCEDURE TitleOptions;
Const credits : array[0..17]of string[30]=('.. the options ..',' ',' * player 1 ..               ',
                                           '* drop speed             ','* beans to link          ',
                                           '* name                   ','* cpu strength           ',
                                           '* input                  ','* key config             ',
                                           '* mouse delay            ',' * player 2 ..               ',
                                           '* drop speed             ','* beans to link          ',
                                           '* name                   ','* cpu strength           ',
                                           '* input                  ','* key config             ',
                                           '* mouse delay            ');
      config : array[0..3]of string[6]=('left','right','rotate','down');
 Var v,keypos : word; f : file;
     constr : string[2];
     ch : char; k : byte;
BEGIN

  repeat
    UpdateLoop;
  until not keypressed;

  global:=0;
  global2:=0;
  keypos:=0;
  paused:=false;
  paused2:=false;
  @timerrelatedproc:=@timertitle2;
  calltimerrelatedproc:=true;

  repeat
    UpdateLoop;

   moved(vscr2,vscr,64000);

   for v:=0 to 17 do
    writestr(vscr,credits[v],320,v*22+13,4);

   with gamev[1] do begin
    str(speed,constr); writestr(vscr,constr,500,3*22+13,4);
    str(blobexplode,constr); writestr(vscr,constr,500,4*22+13,4);
    str(cpuv.iq,constr); writestr(vscr,constr,500,6*22+13,4);
    str(mousesens,constr); writestr(vscr,constr,500,9*22+13,4);
    writestr(vscr,name,500,5*22+13,4);
    if joy1 then writestr(vscr,'joypad1',500,7*22+13,4)
     else if joy2 then writestr(vscr,'joypad2',500,7*22+13,4)
      else if mouse1 then writestr(vscr,'mouse',500,7*22+13,4)
       else writestr(vscr,'keyboard',500,7*22+13,4);
   end;
   with gamev[2] do begin
    str(speed,constr); writestr(vscr,constr,500,11*22+13,4);
    str(blobexplode,constr); writestr(vscr,constr,500,12*22+13,4);
    str(cpuv.iq,constr); writestr(vscr,constr,500,14*22+13,4);
    str(mousesens,constr); writestr(vscr,constr,500,17*22+13,4);
    writestr(vscr,name,500,13*22+13,4);
    if joy1 then writestr(vscr,'joypad1',500,15*22+13,4)
     else if joy2 then writestr(vscr,'joypad2',500,15*22+13,4)
      else if mouse1 then writestr(vscr,'mouse',500,15*22+13,4)
       else writestr(vscr,'keyboard',500,15*22+13,4);
   end;

   case global of
    0..6 : begin putsprt100(vscr,15,(global+3)*22+13,sprptr[0]); putsprt100(vscr,625,(global+3)*22+13,sprptr[1]); end;
    7..13: begin putsprt100(vscr,15,(global+4)*22+13,sprptr[0]); putsprt100(vscr,625,(global+4)*22+13,sprptr[1]); end;
   end;

   copyscreen100(vscr);

   if paused then begin
    repeat
	 UpdateLoop;
    until not keypressed;
    repeat
	 UpdateLoop;
     ch:=readchar;
    until (ch<>chr(0));
    putchannel(waves[14],30,1);
    inc(keypos);
    case global of
     2 : gamev[1].name[keypos]:=ch;
     9 : gamev[2].name[keypos]:=ch;
    end;
    if (keypos=5) then begin
	  keypos:=0; putchannel(waves[18],20,1);
	  repeat 
		UpdateLoop;
	  until not keypressed;
	  paused:=false;
	end;
   end;

   if paused2 then begin
    case global of
     5 : writestr(vscr,config[keypos],500,8*22+13,4);
     12: writestr(vscr,config[keypos],500,16*22+13,4);
    end;
    copyscreen100(vscr);
    repeat
	 UpdateLoop;
    until not keypressed;
    repeat
	 UpdateLoop;
     k:=readkey;
    until (k<>0);
    putchannel(waves[14],30,1);
    case global of
     5  : gamev[1].keyb[keypos]:=k;
     12 : gamev[2].keyb[keypos]:=k;
    end;
    inc(keypos);
    if (keypos=4) then begin 
	  keypos:=0; putchannel(waves[18],20,1);
	  repeat
	    UpdateLoop;
	  until not keypressed;
	  paused2:=false;
	end;
   end;

  until keys[1];

  putchannel(waves[18],20,1);

  calltimerrelatedproc:=false;

  filemode:=2;
  {$I-}
  assign(f,'data/mbm2000.cfg');
  reset(f,1);
  if (ioresult=0) then begin
   blockwrite(f,gamev[1],Ofs(gamev[1].cpuv.x) - Ofs(gamev[1].mouse1));
   blockwrite(f,gamev[2],Ofs(gamev[2].cpuv.x) - Ofs(gamev[2].mouse1));
   close(f);
  end;
  {$I+}
  filemode:=0;

  fadeout(palette);

END;



PROCEDURE TimerTitle;
BEGIN

  if (global2 mod 7=0) then begin
   if keys[$48] and (global>0) then begin dec(global); putchannel(waves[13],20,1); end;
   if keys[$50] and (global<6) then begin inc(global); putchannel(waves[13],20,1); end;
   if keys[1] then exitgame:=true;
   if keys[32] then global:=666;  { CHEAT = D }
  end;

  if (global2<139) then inc(global2) else global2:=0;

END;


PROCEDURE Title_MBM;
 Const titles : array[0..6]of string[12]=('single human','human vs cpu','2 humans vs','credits',
                                          'options','help','exit');
 Var ainc : array [0..3] of linsprite;
     v,v2 : word;
 Label titlestart;

BEGIN
  titlestart:

  filld(vscr,64000,0);
  copyscreen100(vscr);
  pcx_2_mem(vscr,'data/mbm2000.p22',true);
  
  for v:=0 to 3 do begin
   ainc[v].adr:=PUint8(vscr) + v * 64000;
   ainc[v].dtx:=640;
   ainc[v].dty:=100;
  end;

  filld(vscr2,64000,0);

  putchannel(waves[17],30,1);
  global:=0;
  @timerrelatedproc:=@timerintro;
  calltimerrelatedproc:=true;
  
  repeat
   UpdateLoop;
   
   putsolidsprt100(vscr2,320,-global-270,ainc[0]);
   putsolidsprt100(vscr2,-320-global shl 1,150,ainc[1]);
   putsolidsprt100(vscr2,global shl 1+960,250,ainc[2]);
   putsolidsprt100(vscr2,320,670+global,ainc[3]);

   waitretrace;
   copyscreen100(vscr2);

  until keypressed or (global<=-316);

  calltimerrelatedproc:=false;

  repeat
	UpdateLoop;
  until not keypressed;

  global:=700;
  @timerrelatedproc:=@timerintro;
  calltimerrelatedproc:=true;

  repeat
   UpdateLoop;
   moved(vscr,vscr2,64000);

   case global of
    60..700 : putdotscalsprt100(vscr2,global shl 1+200,190,500,500,spr2000);
    0..59   : putdotscalsprt100(vscr2,320,190,500,500,spr2000);
    -399..-1 : putdotscalsprt100(vscr2,320,190,500+global,500+global,spr2000);
    -1250..-400 : putsprt100(vscr2,320,190,spr2000);
   end;

   waitretrace;
   copyscreen100(vscr2);

  until keypressed or (global<=-1200);

  calltimerrelatedproc:=false;

  moved(vscr,vscr2,64000);
  putsprt100(vscr2,320,190,spr2000);
  copyscreen100(vscr2);
  for v:=0 to 4 do
   for v2:=0 to 7 do
    putsprt100(vscr2,v*150+75,v2*50+25,sprshade);

  repeat
    UpdateLoop;
  until not keypressed;

  putchannel(waves[15],35,2);
  global:=0;
  global2:=0;
  @timerrelatedproc:=@timertitle;
  calltimerrelatedproc:=true;

  repeat
   UpdateLoop;
   moved(vscr2,vscr,64000);

   for v:=0 to 2 do
    writestr(vscr,titles[v],320,v*50+25,3);
   for v:=3 to 5 do
    writestr(vscr,titles[v],320,v*50+50,3);
   writestr(vscr,titles[6],320,375,3);

   case global of
    0..2 : begin putsprt100(vscr,15,global*50+25,sprptr[0]); putsprt100(vscr,625,global*50+25,sprptr[1]); end;
    3..5 : begin putsprt100(vscr,15,global*50+50,sprptr[0]); putsprt100(vscr,625,global*50+50,sprptr[1]); end;
    6    : begin putsprt100(vscr,15,375,sprptr[0]); putsprt100(vscr,625,375,sprptr[1]); end;
   end;

   waitretrace;
   copyscreen100(vscr);
   
  until keys[$1c] or keys[$39] or exitgame or (global=666);
  
  calltimerrelatedproc:=false;

  putchannel(waves[18],20,1);

  if not exitgame then case global of
   0 : begin gamev[1].cpu:=false; gamev[2].cpu:=false; gamev[1].outoforder:=false; gamev[2].outoforder:=true; end;
   1 : begin gamev[1].cpu:=false; gamev[2].cpu:=true; gamev[1].outoforder:=false; gamev[2].outoforder:=false; end;
   2 : begin gamev[1].cpu:=false; gamev[2].cpu:=false; gamev[1].outoforder:=false; gamev[2].outoforder:=false; end;
   3 : begin creditshelp(true); goto titlestart; end;
   4 : begin titleoptions; goto titlestart; end;
   5 : begin creditshelp(false); goto titlestart; end;
   6 : exitgame:=true;
   666 : begin gamev[1].cpu:=true; gamev[2].cpu:=true; gamev[1].outoforder:=false; gamev[2].outoforder:=false; end;
  end;

  fadeout(palette);

END;


{----------------------------------------------------------------------------}


PROCEDURE Highscore_MBM;
 Var v,v2 : word;
     convstr : string[10];
BEGIN

  filld(vscr,64000,0);
  copyscreen100(vscr);
  pcx_2_mem(vscr2,'data/mbm2000.p02',true);

  writestr(vscr,'killer kings',320,20,3);

  for v:=1 to 8 do begin
   str(highscore.score[v],convstr);
   if (length(convstr)<10) then
    repeat
     convstr:='0'+convstr;
    until length(convstr)=10;
   writestr(vscr,chr(v+48)+'.'+highscore.scorename[v]+'  '+convstr+' pts.',320,v*44+18,4);
   str(highscore.kills[v],convstr);
   writestr(vscr,convstr+' beans killed',320,v*44+38,4);
  end;

  fillchar(palette2,768,0);
  setpalette(@palette2);
  copyscreen100(vscr);
  
  fadein(palette, palette2);

  repeat
    UpdateLoop;
  until not keypressed;
  repeat
	UpdateLoop;
  until keypressed;

  putchannel(waves[18],20,1);

  move(palette2,palette,768);

  fadeout(palette2);

  filld(vscr,64000,0);
  writestr(vscr,'combo demons',320,20,3);

  for v:=1 to 8 do begin
   str(highscore.combo[v].hits,convstr);
   if (length(convstr)<2) then convstr:='0'+convstr;
   writestr(vscr,chr(v+48)+'.'+highscore.comboname[v]+'  '+convstr+' hit-combo',320,v*44+18,4);
   str(highscore.combo[v].score,convstr);
   writestr(vscr,convstr+' pts.scored',320,v*44+38,4);
  end;

  fillchar(palette2,768,0);
  setpalette(@palette2);
  copyscreen100(vscr);
  
  fadein(palette, palette2);

  repeat
   UpdateLoop;
  until not keypressed;
  repeat
    UpdateLoop;
  until keypressed;

  putchannel(waves[18],20,1);

  move(palette2,palette,768);

  fadeout(palette2);

END;


{----------------------------------------------------------------------------}


PROCEDURE WriteInfostr(info : string);
 Var v : word;
BEGIN

  if infostr[4]<>'' then begin
   for v:=0 to 3 do
    infostr[v]:=infostr[v+1];
   infostr[4]:=info;
  end else
   for v:=0 to 4 do
    if infostr[v]='' then begin
     if (v=0) then infoani:=0;
     infostr[v]:=info;
     exit;
    end;

END;


PROCEDURE ShowInfos;
 Var v,v2 : word;
     flicspr : linsprite;
     speedstr : string[2];
BEGIN

  for v:=0 to 4 do
   writestr(vscr,infostr[v],319,112+v*14,1);

  writestr(vscr,fps,319,10,2);

  str(gamev[1].speed*gamev[1].incspeed,speedstr);
  if not gamev[1].outoforder then writestr(vscr,'level:'+speedstr,275,391,1);
  str(gamev[2].speed*gamev[2].incspeed,speedstr);
  if not gamev[2].outoforder then writestr(vscr,'level:'+speedstr,365,391,1);

  for v:=1 to 6 do with gamev[1] do
   if (numcol[v]>0) then for v2:=1 to numcol[v] do line100(vscr,245+v2 shl 1,274+v*15,245+v2 shl 1,282+v*15,maincol[v]);
  for v:=1 to 6 do with gamev[2] do
   if (numcol[v]>0) then for v2:=1 to numcol[v] do line100(vscr,395-v2 shl 1,274+v*15,395-v2 shl 1,282+v*15,maincol[v]);

  flicspr.dtx:=78;
  flicspr.dty:=48;
  flicspr.adr:=flic[flicani shr 2];
  putdotscalsprt100(vscr,320,329,200,200,flicspr);

END;



PROCEDURE Check4Dead(v : word;xv,yv : integer;col : word);
 Var feld : array[-1..6,-1..13]of boolean;
     dead,dead2,v2 : word;
     deadstr : string[2];

 PROCEDURE checkblob(x,y : integer);
 BEGIN

   if (gamev[v].blobfeld[x-1,y].col=col) and not feld[x-1,y] then begin
    inc(dead); feld[x-1,y]:=true; checkblob(x-1,y);
   end;

   if (gamev[v].blobfeld[x+1,y].col=col) and not feld[x+1,y] then begin
    inc(dead); feld[x+1,y]:=true; checkblob(x+1,y);
   end;

   if (gamev[v].blobfeld[x,y-1].col=col) and not feld[x,y-1] then begin
    inc(dead); feld[x,y-1]:=true; checkblob(x,y-1);
   end;

   if (gamev[v].blobfeld[x,y+1].col=col) and not feld[x,y+1] then begin
    inc(dead); feld[x,y+1]:=true; checkblob(x,y+1);
   end;

 END;

 PROCEDURE killblob(x,y : integer);
 BEGIN

   with gamev[v] do begin

    killfeld[x,y].col:=col;
    killfeld[x,y].ani:=1;

    blobfeld[x,y].col:=0;
    blobfeld[x,y].typ:=0;

    if (blobfeld[x-1,y].col=col) and not feld[x-1,y] then begin
     feld[x-1,y]:=true; killblob(x-1,y);
    end;

    if (blobfeld[x+1,y].col=col) and not feld[x+1,y] then begin
     feld[x+1,y]:=true; killblob(x+1,y);
    end;

    if (blobfeld[x,y-1].col=col) and not feld[x,y-1] then begin
     feld[x,y-1]:=true; killblob(x,y-1);
    end;

    if (blobfeld[x,y+1].col=col) and not feld[x,y+1] then begin
     feld[x,y+1]:=true; killblob(x,y+1);
    end;

    if (blobfeld[x-1,y].col=1) and not feld[x-1,y] then begin
     feld[x-1,y]:=true; killfeld[x-1,y].col:=1;
     killfeld[x-1,y].ani:=1; blobfeld[x-1,y].col:=0; blobfeld[x-1,y].typ:=0;
    end;

    if (blobfeld[x+1,y].col=1) and not feld[x+1,y] then begin
     feld[x+1,y]:=true; killfeld[x+1,y].col:=1;
     killfeld[x+1,y].ani:=1; blobfeld[x+1,y].col:=0; blobfeld[x+1,y].typ:=0;
    end;

    if (blobfeld[x,y-1].col=1) and not feld[x,y-1] then begin
     feld[x,y-1]:=true; killfeld[x,y-1].col:=1;
     killfeld[x,y-1].ani:=1; blobfeld[x,y-1].col:=0; blobfeld[x,y-1].typ:=0;
    end;

    if (blobfeld[x,y+1].col=1) and not feld[x,y+1] then begin
     feld[x,y+1]:=true; killfeld[x,y+1].col:=1;
     killfeld[x,y+1].ani:=1; blobfeld[x,y+1].col:=0; blobfeld[x,y+1].typ:=0;
    end;

   end;

 END;


BEGIN

   fillchar(feld,sizeof(feld),0);
   for v2:=0 to 12 do begin
    feld[-1,v2]:=true;
    feld[6,v2]:=true;
   end;
   for v2:=0 to 5 do begin
    feld[v2,-1]:=true;
    feld[v2,13]:=true;
   end;

   dead:=0;
   checkblob(xv,yv);
   if (dead>=gamev[v].blobexplode) then with gamev[v] do begin
    putchannel(waves[3],20,2+(v-1) shl 2);
    inc(combo);

    inc(killsrecord,dead);
    if (killsrecord div 60>incspeed-1) and (incspeed<13) then begin
     inc(incspeed);
     if (v=1) then writeinfostr('inc(speed)....') else writeinfostr('....inc(speed)');
    end;

    inc(killed,(dead-2)*combo);

    if (dead>15) then dead2:=15 else dead2:=dead;
    case dead of
     1..9 : deadstr:=chr(dead+48);
     else deadstr:=chr(dead div 10+48)+chr(dead mod 10+48);
    end;
    if (v=1) then writeinfostr(combostr[dead2]+'('+deadstr+')....') else
     writeinfostr('....'+combostr[dead2]+'('+deadstr+')');

    inc(score2,500*(dead-3));
    str(500*(dead-3),killfeld[xv,yv].score);
    killfeld[xv,yv].y:=1;

    fillchar(feld,sizeof(feld),0);
    for v2:=0 to 12 do begin
     feld[-1,v2]:=true;
     feld[6,v2]:=true;
    end;
    for v2:=0 to 5 do begin
     feld[v2,-1]:=true;
     feld[v2,13]:=true;
    end;
    killblob(xv,yv);
   end;

END;



FUNCTION Blob_NoHit(v : word;dx,dy : integer) : boolean;
BEGIN

  with gamev[v] do
   if (blobfeld[currblob[1].x+dx,currblob[1].y+dy].col=0)
    and (blobfeld[currblob[2].x+dx,currblob[2].y+dy].col=0)
    and (currblob[1].x+dx<6) and (currblob[1].x+dx>-1)
    and (currblob[1].y+dy<13) and (currblob[2].x+dx<6)
    and (currblob[2].x+dx>-1) and (currblob[2].y+dy<13) then blob_nohit:=true
     else blob_nohit:=false;

END;



PROCEDURE Blob_Hit(v : word;x,y : integer);
BEGIN

  if (gamev[v].blobfeld[x,y].col<=1) or (y<0) then exit;

  with gamev[v] do begin

   if (blobfeld[x,y+1].col=blobfeld[x,y].col) then begin
    blobfeld[x,y].typ:=blobfeld[x,y].typ or 8;  {un}
    blobfeld[x,y+1].typ:=blobfeld[x,y+1].typ or 4;
   end;
   if (blobfeld[x,y-1].col=blobfeld[x,y].col) then begin
    blobfeld[x,y].typ:=blobfeld[x,y].typ or 4;  {ob}
    blobfeld[x,y-1].typ:=blobfeld[x,y-1].typ or 8;
   end;
   if (blobfeld[x+1,y].col=blobfeld[x,y].col) then begin
    blobfeld[x,y].typ:=blobfeld[x,y].typ or 2;  {re}
    blobfeld[x+1,y].typ:=blobfeld[x+1,y].typ or 1;
   end;
   if (blobfeld[x-1,y].col=blobfeld[x,y].col) then begin
    blobfeld[x,y].typ:=blobfeld[x,y].typ or 1;  {li}
    blobfeld[x-1,y].typ:=blobfeld[x-1,y].typ or 2;
   end;

   check4dead(v,x,y,blobfeld[x,y].col);

  end;

END;



PROCEDURE Calculate_Cpu(v3 : word);
 Var v : word;

 FUNCTION RowColFirst(p,x : word) : word;
  Var y : word;
 BEGIN
   if (gamev[p].blobfeld[x,0].col=0) then
    for y:=1 to 12 do
     if (gamev[p].blobfeld[x,y].col<>0) then begin rowcolfirst:=gamev[p].blobfeld[x,y].col; exit; end;
   rowcolfirst:=0;
 END;

BEGIN

  with gamev[v3] do begin

   for v:=0 to 5 do
    if (currblob[1].col=currblob[2].col) and (rowcolfirst(v3,v)=currblob[1].col) then begin
     cpuv.x:=v; cpuv.rotation:=0; exit;
    end;

   for v:=0 to 4 do begin
    if (rowcolfirst(v3,v)=currblob[1].col) and (rowcolfirst(v3,v+1)=currblob[2].col) then begin
     cpuv.x:=v; cpuv.rotation:=3; exit;
    end;
    if (rowcolfirst(v3,v)=currblob[2].col) and (rowcolfirst(v3,v+1)=currblob[1].col) then begin
     cpuv.x:=v+1; cpuv.rotation:=1; exit;
    end;
   end;

   for v:=0 to 4 do begin
    if (rowcolfirst(v3,v)=currblob[1].col) and (rowcolfirst(v3,v+1)=0) then begin
     cpuv.x:=v; cpuv.rotation:=3; exit;
    end;
    if (rowcolfirst(v3,v)=currblob[2].col) and (rowcolfirst(v3,v+1)=0) then begin
     cpuv.x:=v+1; cpuv.rotation:=1; exit;
    end;
    if (rowcolfirst(v3,v)=0) and (rowcolfirst(v3,v+1)=0) then begin
     cpuv.x:=v; cpuv.rotation:=3; exit;
    end;
   end;

   for v:=0 to 4 do begin
    if (rowcolfirst(v3,v)=currblob[1].col) then begin
     cpuv.x:=v; cpuv.rotation:=3; exit;
    end;
    if (rowcolfirst(v3,v)=currblob[2].col) then begin
     cpuv.x:=v+1; cpuv.rotation:=1; exit;
    end;
   end;

   cpuv.x:=random(5)+1; cpuv.rotation:=1;
  end;

END;


FUNCTION CheckLine(p,v : integer;var hole : integer) : boolean;
 Var v2 : integer;
BEGIN

  checkline:=false;
  for v2:=-9 to 12 do
   if (gamev[p].blobfeld[v,v2].col=0) and (gamev[p].blobfeld[v,v2-1].col<>0) then begin checkline:=true; hole:=v2; exit; end;

END;



PROCEDURE CheckFelder;
 Var v,v2,v3,y : integer;
     stillfalling : boolean;
     blobstr : string[3];
     r,b : word;
BEGIN


  for v3:=1 to 2 do with gamev[v3] do if not outoforder then begin
   fillchar(numcol,sizeof(numcol),0);
   stillfalling:=false;

   for v:=0 to 5 do begin

    for v2:=0 to 12 do if (blobfeld[v,v2].col<>0) then inc(numcol[blobfeld[v,v2].col]);

    if checkline(v3,v,y) then begin
     for v2:=y-1 downto -10 do begin
      blobfeld[v,v2+1]:=blobfeld[v,v2];
      blobfeld[v+1,v2].typ:=blobfeld[v+1,v2].typ and not 1;
      blobfeld[v-1,v2].typ:=blobfeld[v-1,v2].typ and not 2;
      blobfeld[v,v2+1].typ:=blobfeld[v,v2+1].typ and not 1;
      blobfeld[v,v2+1].typ:=blobfeld[v,v2+1].typ and not 2;
      fillchar(blobfeld[v,v2],sizeof(blobfeld[v,v2]),0);
     end;
     if checkline(v3,v,y) then begin
      stillfalling:=true;
     end else for v2:=0 to 12 do blob_hit(v3,v,v2);
    end;
   end;

   for v:=1 to 6 do if (numcol[v]>30) then numcol[v]:=30;

   if (combo>1) and not stillfalling then begin
    if (combo<8) then putchannel(waves[combo+2],30,1+(v3-1) shl 2) else putchannel(waves[10],30,1+(v3-1) shl 2);
    combogfx.ani:=1;
    if (combogfx.typ>8) then combogfx.typ:=8 else combogfx.typ:=combo;
    inc(score2,combo*killed*200);
    str(combo*killed*200,combogfx.scorestr);
    combogfx.scorestr:=combogfx.scorestr+' pts.';

    if (combo>comborecord.hits) then begin
     comborecord.hits:=combo;
     comborecord.score:=combo*killed*200;
    end;
   end;

   if not stillfalling then begin
    if (killed>0) then case v3 of
     1 : if (blackblobs=0) then inc(gamev[2].blackblobs,killed) else
          if (blackblobs>=killed) then dec(blackblobs,killed) else begin
           dec(killed,blackblobs); inc(gamev[2].blackblobs,killed); blackblobs:=0;
           combogfx.scorestr:='20000 pts.'; combogfx.ani:=1; combogfx.typ:=0; inc(score2,20000);
           putchannel(waves[11],40,1+(v3-1) shl 2);
          end;
     2 : if (blackblobs=0) then inc(gamev[1].blackblobs,killed) else
          if (blackblobs>=killed) then dec(blackblobs,killed) else begin
           dec(killed,blackblobs); inc(gamev[1].blackblobs,killed); blackblobs:=0;
           combogfx.scorestr:='20000 pts.'; combogfx.ani:=1; combogfx.typ:=0; inc(score2,20000);
           putchannel(waves[11],40,1+(v3-1) shl 2);
          end;
    end;

    if cpu and controljam and (blackblobs=0) then calculate_cpu(v3);

    if controljam and (blackblobs>0) then begin
     if ((blackblobs div 6)>0) then
      for v:=1 to (blackblobs div 6) do
       for v2:=0 to 5 do begin
        blobfeld[v2,v-11].col:=1;
        blobfeld[v2,v-11].ani:=random(16);
       end;

     r:=random(6-blackblobs mod 6);
     b:=blackblobs div 6;

     if ((blackblobs mod 6)>0) then
      for v2:=r to (blackblobs mod 6)-1+r do begin
       blobfeld[v2,b-10].col:=1;
       blobfeld[v2,b-10].ani:=random(16);
      end;
     blackblobs:=0;
    end else controljam:=false;

    combo:=0;
    killed:=0;
    if (blobfeld[3,0].col<>0) then begin gameover:=true; putchannel(waves[12],30,1+(v3-1) shl 2); end;
   end;

  end;


END;


PROCEDURE CurrBlob_Hit(v : word);
 Var v2,v3 : word;
BEGIN

  putchannel(waves[2],15,3+(v-1) shl 2);

  with gamev[v] do begin
   blobfeld[currblob[1].x,currblob[1].y].col:=currblob[1].col;
   blobfeld[currblob[2].x,currblob[2].y].col:=currblob[2].col;

   blobfeld[currblob[1].x,currblob[1].y].ani:=random(16);
   blobfeld[currblob[2].x,currblob[2].y].ani:=random(16);

   blob_hit(v,currblob[1].x,currblob[1].y);
   blob_hit(v,currblob[2].x,currblob[2].y);

   rot:=0;
   currblob[1].x:=3;
   currblob[2].x:=3;
   currblob[1].y:=-3;
   currblob[2].y:=-2;
   currblob[1].col:=nextblob[1];
   currblob[2].col:=nextblob[2];
   currblob[1].ani:=random(16);
   currblob[2].ani:=random(16);
   nextblob[1]:=random(5)+2;
   nextblob[2]:=random(5)+2;

   controljam:=true;
  end;

END;


PROCEDURE Move_Cpu(v : word);
BEGIN

  with gamev[v] do
   if (cpuv.rotation>rot) then up:=true
    else if (cpuv.x<currblob[1].x) then left:=true
     else if (cpuv.x>currblob[1].x) then right:=true
      else case cpuv.iq of
       1 : if (fpscounter mod 5=0) then down:=true;
       2 : if (fpscounter mod 4=0) then down:=true;
       3 : if (fpscounter mod 3=0) then down:=true;
       4 : if (fpscounter mod 2=0) then down:=true;
       5 : down:=true;
      end;

END;


PROCEDURE CheckInput;
 Var v : word;
BEGIN

  if (joy1_ok or joy2_ok) and (gamev[1].joy1 or gamev[2].joy1 or gamev[1].joy2 or gamev[2].joy2)
   then Joystick_Status(joy1_ok,joy2_ok);

  if mouse_ok and (gamev[1].mouse1 or gamev[2].mouse1) then Mouse_Status;

  for v:=1 to 2 do with gamev[v] do if not controljam and not outoforder then begin

   down:=false; left:=false; right:=false; up:=false;

   if not cpu then begin

    if mouse_ok and mouse1 then begin
     if (mouse.x<320-mousesens) then left:=true;
     if (mouse.x>320+mousesens) then right:=true;
     if (mouse.y>200+mousesens) then down:=true;
     if mouse.bl then up:=true;
     putmouse(320,200);
    end;

    if joy1_ok and joy1 then begin
     if (joy.x1<joy_config.xnorm1 shr 1-joy_config.xmin1) then left:=true;
     if (joy.x1>joy_config.xmax1-joy_config.xnorm1 shr 1) then right:=true;
     if (joy.y1>joy_config.ymax1-joy_config.ynorm1 shr 1) then down:=true;
     if joy.b1 or joy.b2 then up:=true;
    end;

    if joy2_ok and joy2 then begin
     if (joy.x2<joy_config.xnorm2 shr 1-joy_config.xmin2) then left:=true;
     if (joy.x2>joy_config.xmax2-joy_config.xnorm2 shr 1) then right:=true;
     if (joy.y2>joy_config.ymax2-joy_config.ynorm2 shr 1) then down:=true;
     if joy.b3 or joy.b4 then up:=true;
    end;

    if keys[keyb[0]] then left:=true;
    if keys[keyb[1]] then right:=true;
    if keys[keyb[2]] then up:=true;
    if keys[keyb[3]] then down:=true;

   end else move_cpu(v);

   if blob_nohit(v,0,+1) then begin
    inc(ytick,speed*incspeed);
    if (ytick>26) then begin
     inc(currblob[1].y);
     inc(currblob[2].y);
     ytick:=0;
    end;
   end else currblob_hit(v);

 end;

END;



PROCEDURE PlayerMove;
 Var v,c : word;
BEGIN

  for v:=1 to 2 do with gamev[v] do if not controljam and not outoforder then begin

   if (xtick=0) then begin
    if left then
     if blob_nohit(v,-1,0) then begin
      xtick:=16;
      dec(currblob[1].x);
      dec(currblob[2].x);
     end;
    if right then
     if blob_nohit(v,+1,0) then begin
      xtick:=-16;
      inc(currblob[1].x);
      inc(currblob[2].x);
     end;
    end;
   if up and (rottick=0) then begin
    putchannel(waves[1],5,4+(v-1) shl 2);
    rottick:=10;
    case rot of
     0 : if blob_nohit(v,+1,0) then begin
          inc(currblob[1].x); inc(currblob[1].y); inc(rot);
         end else begin
          c:=currblob[1].col; currblob[1].col:=currblob[2].col; currblob[2].col:=c;
         end;
     1 : if blob_nohit(v,0,+1) then begin
          dec(currblob[1].x); inc(currblob[1].y); inc(rot);
         end else begin
          c:=currblob[1].col; currblob[1].col:=currblob[2].col; currblob[2].col:=c;
         end;
     2 : if blob_nohit(v,-1,0) then begin
          dec(currblob[1].x); dec(currblob[1].y); inc(rot);
         end else begin
          c:=currblob[1].col; currblob[1].col:=currblob[2].col; currblob[2].col:=c;
         end;
     3 : if blob_nohit(v,0,-1) then begin
          inc(currblob[1].x); dec(currblob[1].y); rot:=0;
         end else begin
          c:=currblob[1].col; currblob[1].col:=currblob[2].col; currblob[2].col:=c;
         end;
    end;
   end;

   if down then begin
    inc(score2,5);
    if blob_nohit(v,0,+1) then begin
     inc(currblob[1].y);
     inc(currblob[2].y);
    end else currblob_hit(v);
   end;

  end;

END;



PROCEDURE ShowFelder;
 Var scorestr : string[10];
     v,v2 : word;
BEGIN

  with gamev[1].currblob[1] do
   putsprt100(vscr,x*33+36+gamev[1].xtick shl 1,y*28+33+gamev[1].ytick,blobs[col,animation[0,ani shr 2]]);
  with gamev[1].currblob[2] do
   putsprt100(vscr,x*33+36+gamev[1].xtick shl 1,y*28+33+gamev[1].ytick,blobs[col,animation[0,ani shr 2]]);

  with gamev[2].currblob[1] do
   putsprt100(vscr,x*33+439+gamev[2].xtick shl 1,y*28+33+gamev[2].ytick,blobs[col,animation[0,ani shr 2]]);
  with gamev[2].currblob[2] do
   putsprt100(vscr,x*33+439+gamev[2].xtick shl 1,y*28+33+gamev[2].ytick,blobs[col,animation[0,ani shr 2]]);


  for v2:=0 to 12 do
   for v:=0 to 5 do begin
    with gamev[1].blobfeld[v,v2] do
     if (col<>0) then putsprt100(vscr,v*33+36,v2*28+33,blobs[col,animation[blobtyp[typ],ani shr 2]]);
    with gamev[2].blobfeld[v,v2] do
     if (col<>0) then putsprt100(vscr,v*33+439,v2*28+33,blobs[col,animation[blobtyp[typ],ani shr 2]]);
   end;

  putsprt100(vscr,118,9,border[1]);
  putsprt100(vscr,522,9,border[2]);

  putsprt100(vscr,118,374,fire[1]);
  putsprt100(vscr,522,374,fire[2]);
  putsprt100(vscr,24,187,fire[3]);
  putsprt100(vscr,213,187,fire[4]);
  putsprt100(vscr,428,187,fire[3]);
  putsprt100(vscr,617,187,fire[4]);


  with gamev[1] do if not outoforder then begin
   str(score,scorestr);
   writestr(vscr,scorestr,118,9,2);
   if (blackblobs>0) and (fpscounter mod 28<14) then begin
    str(blackblobs,scorestr);
    writestr(vscr,'danger -'+scorestr+'-',118,391,0);
   end;
   if gameover then writestr(vscr,'game over',118,190,0);
   putsprt100(vscr,257,35,blobs[nextblob[1],0]);
   putsprt100(vscr,257,63,blobs[nextblob[2],0]);
  end;

  with gamev[2] do if not outoforder then begin
   str(score,scorestr);
   writestr(vscr,scorestr,522,9,2);
   if (blackblobs>0) and (fpscounter mod 28<14) then begin
    str(blackblobs,scorestr);
    writestr(vscr,'danger -'+scorestr+'-',522,391,0);
   end;
   if gameover then writestr(vscr,'game over',522,190,0);
   putsprt100(vscr,383,35,blobs[nextblob[1],0]);
   putsprt100(vscr,383,63,blobs[nextblob[2],0]);
  end;


  for v2:=0 to 12 do
   for v:=0 to 5 do begin
    with gamev[1].killfeld[v,v2] do begin
     if (y<120) and (y>0) then
      writestr(vscr,score,v*33+36,v2*28+33-y shr 1,1);
     if (ani<160) and (ani>0) then
      putdotscalsprt100(vscr,v*33+36,v2*28+33,ani shl 3+100,ani shl 3+100,blobs[col,0]);
    end;
    with gamev[2].killfeld[v,v2] do begin
     if (y<120) and (y>0) then
      writestr(vscr,score,v*33+439,v2*28+33-y shr 1,1);
     if (ani<160) and (ani>0) then
      putdotscalsprt100(vscr,v*33+439,v2*28+33,ani shl 3+100,ani shl 3+100,blobs[col,0]);
    end;
   end;


  with gamev[1].combogfx do
   case ani of
    1..119 : begin putsprt100(vscr,ani shl 1-120,175,combos[typ]);
                   if (typ<>0) then putsprt100(vscr,ani shl 1-120,225,combos[1]);
                   writestr(vscr,scorestr,ani shl 1-120,200,0); end;
    120..199: begin putsprt100(vscr,118,175,combos[typ]);
                    if (typ<>0) then putsprt100(vscr,118,225,combos[1]);
                    writestr(vscr,scorestr,118,200,0); end;
    200..359 : begin writestr(vscr,scorestr,518-ani shl 1,200,0);
                     putdotscalsprt100(vscr,118,175,(ani-199) shl 3+100,(ani-199) shl 3+100,combos[typ]);
                     if (typ<>0) then putdotscalsprt100(vscr,118,225,(ani-199) shl 3+100,(ani-199) shl 3+100,combos[1]); end;
   end;


  with gamev[2].combogfx do
   case ani of
    1..119 : begin putsprt100(vscr,760-ani shl 1,175,combos[typ]);
                   if (typ<>0) then putsprt100(vscr,760-ani shl 1,225,combos[1]);
                   writestr(vscr,scorestr,760-ani shl 1,200,0); end;
    120..199: begin putsprt100(vscr,522,175,combos[typ]);
                    if (typ<>0) then putsprt100(vscr,522,225,combos[1]);
                    writestr(vscr,scorestr,522,200,0); end;
    200..359 : begin writestr(vscr,scorestr,122+ani shl 1,200,0);
                     putdotscalsprt100(vscr,522,175,(ani-199) shl 3+100,(ani-199) shl 3+100,combos[typ]);
                     if (typ<>0) then putdotscalsprt100(vscr,522,225,(ani-199) shl 3+100,(ani-199) shl 3+100,combos[1]); end;
   end;

  if paused and (fpscounter mod 35<25) then begin
   writestr(vscr,'paused',320,314,0);
   writestr(vscr,'exit (y/n)',322,338,0);
  end;

END;



PROCEDURE AnimateFelder;
 Var v,v2,v3 : word;
BEGIN

  for v2:=0 to 12 do
   for v:=0 to 5 do
    for v3:=1 to 2 do with gamev[v3] do begin
     if (killfeld[v,v2].ani<160) and (killfeld[v,v2].ani>0) then inc(killfeld[v,v2].ani);
     if (killfeld[v,v2].y<120) and (killfeld[v,v2].y>0) then inc(killfeld[v,v2].y);
     if (blobfeld[v,v2].ani<127) then inc(blobfeld[v,v2].ani) else blobfeld[v,v2].ani:=0;
    end;

  for v:=1 to 2 do with gamev[v] do begin
   if (currblob[1].ani<127) then inc(currblob[1].ani) else currblob[1].ani:=0;
   if (currblob[2].ani<127) then inc(currblob[2].ani) else currblob[2].ani:=0;
   if (combogfx.ani<360) and (combogfx.ani>0) then inc(combogfx.ani);

   case (score2-score) of
    0 : ;
    1..9 : inc(score);
    10..99 : inc(score,5);
    100..999 : inc(score,50);
    1000..9999 : inc(score,500);
    else inc(score,1000);
   end;

   case xtick of
    -16..-1 : inc(xtick);
     1..16  : dec(xtick);
   end;

   if (rottick>0) then dec(rottick);

  end;

  if (flicani<39) then inc(flicani) else flicani:=0;

  if (infoani<450) then inc(infoani)
   else begin
    for v:=0 to 3 do
     infostr[v]:=infostr[v+1];
    infostr[4]:='';
    infoani:=0;
   end;

END;



PROCEDURE TimerGameplay;
BEGIN

  if (keys[1] or keys[25]) and not paused then paused:=true;
  if paused then begin
   if keys[21] or keys[44] or keys[36] then begin gamev[1].gameover:=true; gamev[2].gameover:=true; paused:=false; end;
   if keys[49] then paused:=false;
  end;

  if (fpscounter mod 4=0) and not paused then playermove;
  if (fpscounter mod 2=0) and not paused then checkinput;
  if (fpscounter mod 5=0) and not paused then checkfelder;
  animatefelder;

  if (fpscounter<139) then inc(fpscounter)
   else begin
    str(fpscounter2 shr 1,fps);
    fpscounter:=0;
    fpscounter2:=0;
   end;

END;



PROCEDURE TimerFight;
BEGIN

  inc(global,3);
  if ((global>=100) and (global<=320)) and (global mod 27=0) then
   if (global2=0) then global2:=1 else global2:=0;

  animatefelder;

  if (fpscounter<139) then inc(fpscounter)
   else begin
    str(fpscounter2 shr 1,fps);
    fpscounter:=0;
    fpscounter2:=0;
   end;

END;


PROCEDURE TimerOuttaHere;
BEGIN

  inc(global,2);
  animatefelder;

  if (fpscounter<139) then inc(fpscounter)
   else begin
    str(fpscounter2 shr 1,fps);
    fpscounter:=0;
    fpscounter2:=0;
   end;

END;



PROCEDURE Play_MBM;
 Var v,v2 : word;
     allstr : string[10];
     f : file;
BEGIN

  fpscounter:=0;
  fpscounter2:=0;
  paused:=false;

  fillchar(infostr,sizeof(infostr),0);
  infoani:=0;
  flicani:=0;
  
  for v:=1 to 2 do with gamev[v] do begin
   cpuv.x:=0;
   cpuv.rotation:=0;

   { HACK: this effectively sets all variables from left until the end of the
           game_state record to 0.}
   fillchar(left,sizeof(gamev[v])-(Ofs(left)-Ofs(mouse1)),0);

   incspeed:=1;

   nextblob[1]:=random(5)+2;
   nextblob[2]:=random(5)+2;

   currblob[1].col:=random(5)+2;
   currblob[1].ani:=random(16);
   currblob[1].x:=3;
   currblob[1].y:=-3;
   currblob[2].col:=random(5)+2;
   currblob[2].ani:=random(16);
   currblob[2].x:=3;
   currblob[2].y:=-2;
  end;
  
  global:=0;
  global2:=0;

  filld(vscr,64000,0);
  copyscreen100(vscr);
  pcx_2_mem(vscr2,'data/mbm2000.p23',true);
  moved(vscr2,vscr,64000);
  showinfos;
  showfelder;
  
  fillchar(palette2,768,0);
  setpalette(@palette2);
  copyscreen100(vscr);
  
  fadein(palette, palette2);

  putchannel(waves[0],35,1);

  @timerrelatedproc:=@timerfight;
  calltimerrelatedproc:=true;
  
  repeat
   UpdateLoop;

   moved(vscr2,vscr,64000);

   showinfos;
   showfelder;
   writestr(vscr,gamev[1].name,global-159,230,1);
   writestr(vscr,gamev[2].name,801-global,230,1);

   case global of
    0..99    : putscalsprt100(vscr,320,global shl 1-50,global,global,fight[global2]);
    100..320 : putsprt100(vscr,320,150,fight[global2]);
    321..420 : putscalsprt100(vscr,320,150,420-global,420-global,fight[global2]);
   end;

   waitretrace;
   copyscreen100(vscr);

   inc(fpscounter2);

  until (global>=420);

  writestr(vscr2,gamev[1].name,262,230,1);
  writestr(vscr2,gamev[2].name,380,230,1);

  calltimerrelatedproc:=false;
  @timerrelatedproc:=@timergameplay;
  calltimerrelatedproc:=true;

  repeat
   UpdateLoop;
   
   moved(vscr2,vscr,64000);

   showinfos;
   showfelder;

   waitretrace;
   copyscreen100(vscr);

   inc(fpscounter2);

  until gamev[1].gameover or gamev[2].gameover;

  calltimerrelatedproc:=false;

  global:=0;

  @timerrelatedproc:=@timerouttahere;
  calltimerrelatedproc:=true;

  repeat
    UpdateLoop;

   
   moved(vscr2,vscr,64000);

   showinfos;
   showfelder;

   case global of
    0..199 : begin
              if not gamev[1].outoforder then begin
               str(gamev[1].comborecord.hits,allstr);
               writestr(vscr,'maximum combo '+allstr+' hits',global shl 1-282,240,1);
               putsprt100(vscr,960-global shl 1,60,winlos[byte(gamev[1].gameover)]);
              end;
              if not gamev[2].outoforder then begin
               putsprt100(vscr,global shl 1-320,340,winlos[byte(gamev[2].gameover)]);
               str(gamev[2].comborecord.hits,allstr);
               writestr(vscr,'maximum combo '+allstr+' hits',922-global shl 1,240,1);
              end;
             end;
    200..399 : begin
                if not gamev[1].outoforder then begin
                 str(gamev[1].comborecord.hits,allstr);
                 writestr(vscr,'maximum combo '+allstr+' hits',118,240,1);
                 str(gamev[1].comborecord.score,allstr);
                 writestr(vscr,allstr+' pts.scored',global shl 1-682,255,1);
                 putsprt100(vscr,960-global shl 1,60,winlos[byte(gamev[1].gameover)]);
                end;
                if not gamev[2].outoforder then begin
                 putsprt100(vscr,global shl 1-320,340,winlos[byte(gamev[2].gameover)]);
                 str(gamev[2].comborecord.hits,allstr);
                 writestr(vscr,'maximum combo '+allstr+' hits',522,240,1);
                 str(gamev[2].comborecord.score,allstr);
                 writestr(vscr,allstr+' pts.scored',1322-global shl 1,255,1);
                end;
               end;
    400..599 : begin
                if not gamev[1].outoforder then begin
                 str(gamev[1].comborecord.hits,allstr);
                 writestr(vscr,'maximum combo '+allstr+' hits',118,240,1);
                 str(gamev[1].comborecord.score,allstr);
                 writestr(vscr,allstr+' pts.scored',118,255,1);
                 str(gamev[1].killsrecord,allstr);
                 writestr(vscr,allstr+' beans killed',global shl 1-1082,280,1);
                 putsprt100(vscr,160,60,winlos[byte(gamev[1].gameover)]);
                end;
                if not gamev[2].outoforder then begin
                 putsprt100(vscr,480,340,winlos[byte(gamev[2].gameover)]);
                 str(gamev[2].comborecord.hits,allstr);
                 writestr(vscr,'maximum combo '+allstr+' hits',522,240,1);
                 str(gamev[2].comborecord.score,allstr);
                 writestr(vscr,allstr+' pts.scored',522,255,1);
                 str(gamev[2].killsrecord,allstr);
                 writestr(vscr,allstr+' beans killed',1722-global shl 1,280,1);
                end;
               end;
    600..2100 : begin
                 if not gamev[1].outoforder then begin
                  str(gamev[1].comborecord.hits,allstr);
                  writestr(vscr,'maximum combo '+allstr+' hits',118,240,1);
                  str(gamev[1].comborecord.score,allstr);
                  writestr(vscr,allstr+' pts.scored',118,255,1);
                  str(gamev[1].killsrecord,allstr);
                  writestr(vscr,allstr+' beans killed',118,280,1);
                  putsprt100(vscr,160,60,winlos[byte(gamev[1].gameover)]);
                 end;
                 if not gamev[2].outoforder then begin
                  putsprt100(vscr,480,340,winlos[byte(gamev[2].gameover)]);
                  str(gamev[2].comborecord.hits,allstr);
                  writestr(vscr,'maximum combo '+allstr+' hits',522,240,1);
                  str(gamev[2].comborecord.score,allstr);
                  writestr(vscr,allstr+' pts.scored',522,255,1);
                  str(gamev[2].killsrecord,allstr);
                  writestr(vscr,allstr+' beans killed',522,280,1);
                 end;
               end;
   end;

   waitretrace;
   copyscreen100(vscr);

   inc(fpscounter2);

  until (global>=2000) or (keypressed and (global>=600));

  calltimerrelatedproc:=false;


  for v:=1 to 2 do with gamev[v] do if not outoforder and not cpu then begin

   global:=10;
   for v2:=9 downto 1 do
    if (score>highscore.score[v2]) or
     ((score=highscore.score[v2]) and (killsrecord>highscore.kills[v2])) then global:=v2;
   if (global<9) then begin
    for v2:=8 downto global do begin
     highscore.score[v2+1]:=highscore.score[v2];
     highscore.kills[v2+1]:=highscore.kills[v2];
     highscore.scorename[v2+1]:=highscore.scorename[v2];
    end;
    highscore.score[global]:=score;
    highscore.kills[global]:=killsrecord;
    highscore.scorename[global]:=name;
   end;

   global:=10;
   for v2:=9 downto 1 do
    if (comborecord.hits>highscore.combo[v2].hits) or
     ((comborecord.hits=highscore.combo[v2].hits) and (comborecord.score>highscore.combo[v2].score)) then global:=v2;
   if (global<9) then begin
    for v2:=8 downto global do begin
     highscore.combo[v2+1]:=highscore.combo[v2];
     highscore.comboname[v2+1]:=highscore.comboname[v2];
    end;
    highscore.combo[global]:=comborecord;
    highscore.comboname[global]:=name;
   end;
  end;

  filemode:=2;
  {$I-}
  assign(f,'data/mbm2000.hig');
  reset(f,1);
  if (ioresult=0) then begin
   blockwrite(f,highscore,sizeof(highscore));
   close(f);
  end;
  {$I+}
  filemode:=0;

  fadeout(palette);

END;


{----------------------------------------------------------------------------}

BEGIN

   filemode:=0;
   randomize;

   Startup_Screen;
   Init_MBM; 
   Intro_MBM;
   exitgame:=false;

   repeat
	
    Title_MBM;
    if not exitgame then begin
     Play_MBM;
     Highscore_MBM;
    end;

   until exitgame;

   Outta_Here(true);

END.
