{$B-,I+,R-,S-,T-,X+}

{(C)2006 Game ported by MARKUS TRENKWALDER }

unit util;

interface

type
	Int8  = ByteInt;
	Int16 = ShortInt;
	Int32 = CInteger;
	
	UInt8  = ByteCard;
	UInt16 = ShortCard;
	UInt32 = CWord;
	
	PInt8  = ^Int8;
	PInt16 = ^Int16;
	PInt32 = ^Int32;
		
	PUInt8  = ^Int8;
	PUInt16 = ^Int16;
	PUInt32 = ^Int32;

	
var
	timerrelatedproc : procedure;   { Benutzerdefinierte Proc. die 70 mal/sec aufgerufen wird }
	calltimerrelatedproc : boolean; { Proc aufrufen ? }
	
function  GlobalAllocPtr (unused : word; size : SizeType) : pointer;
procedure GlobalFreePtr  (ptr : pointer);	
procedure UpdateLoop;

function ProcessEvents : Uint32; external name "ProcessEvents";

implementation

function GlobalAllocPtr(unused : word; size : SizeType) : pointer;
var	ptr : pointer;
begin
	GetMem(ptr, size);
	GlobalAllocPtr := ptr;
end;

procedure GlobalFreePtr(ptr : pointer);	
begin
	FreeMem(ptr);
end;

procedure UpdateLoop;
var count : Uint32;
begin
	count := ProcessEvents;
	if calltimerrelatedproc then 
		while count > 0 do begin
			timerrelatedproc;
			dec(count);
		end;
end;

begin
	calltimerrelatedproc := false;
end.
