{$B-,I+,R-,S-,T-,X+}

{(C)98 by CARSTEN WAECHTER aka THE TOXIC AVENGER}
{(C)2006 Game ported by MARKUS TRENKWALDER }

Unit CONTROL;

INTERFACE

Uses WINDOS;

Type Joy_data = record
                 b1,b2,b3,b4 : boolean;
                 x1,y1,x2,y2 : word;
                end;
     Joy_data2= record
                 xnorm1,ynorm1,xnorm2,ynorm2 : word;
                 xmin1,xmax1,ymin1,ymax1 : word;
                 xmin2,xmax2,ymin2,ymax2 : word;
                end;
Type Mouse_data = record
                 bl,br,bm : boolean;
                 x,y : word;
                end;

Var  keys : array[0..127]of CBoolean; external name "keys";

     Joy : Joy_data;
     Joy_config : Joy_data2;
     Mouse : Mouse_data;


FUNCTION  KeyPressed : boolean;
FUNCTION  ReadKey : byte;
FUNCTION  ReadChar: char;

FUNCTION  Joystick1_Installed : boolean;
FUNCTION  Joystick2_Installed : boolean;
PROCEDURE Joystick_Status(j1, j2 : boolean);

FUNCTION  InitMouse : word;
PROCEDURE Mouse_Status;
PROCEDURE PutMouse(x,y : word);


IMPLEMENTATION

FUNCTION  KeyPressed;
 Var v : byte;
BEGIN

  keypressed:=false;

  for v:=1 to 127 do if keys[v] then begin keypressed:=true; exit; end;

END;


FUNCTION  ReadKey;
 Var v : byte;
BEGIN

  readkey:=0;

  for v:=1  to 41  do if keys[v] then begin readkey:=v; exit; end;
  for v:=43 to 127 do if keys[v] then begin readkey:=v; exit; end;

END;


FUNCTION  ReadChar;
 Var v : byte;
BEGIN

  readchar:=chr(0);

  for v:=1 to 127 do if keys[v] then
   begin
    case v of
     2..10 : readchar:=chr(v+47);
     11    : readchar:=chr(48);
     13    : readchar:=chr(39);
     16    : readchar:=chr(113);
     17    : readchar:=chr(119);
     18    : readchar:=chr(101);
     19    : readchar:=chr(114);
     20    : readchar:=chr(116);
     21    : readchar:=chr(122);
     22    : readchar:=chr(117);
     23    : readchar:=chr(105);
     24    : readchar:=chr(111);
     25    : readchar:=chr(112);
     27    : readchar:=chr(43);
     30    : readchar:=chr(97);
     31    : readchar:=chr(115);
     32    : readchar:=chr(100);
     33    : readchar:=chr(102);
     34    : readchar:=chr(103);
     35    : readchar:=chr(104);
     36    : readchar:=chr(106);
     37    : readchar:=chr(107);
     38    : readchar:=chr(108);
     41    : readchar:=chr(35);
     44    : readchar:=chr(121);
     45    : readchar:=chr(120);
     46    : readchar:=chr(99);
     47    : readchar:=chr(118);
     48    : readchar:=chr(98);
     49    : readchar:=chr(110);
     50    : readchar:=chr(109);
     51    : readchar:=chr(44);
     52    : readchar:=chr(46);
     53    : readchar:=chr(45);
     55    : readchar:=chr(42);
     57    : readchar:=chr(32);
    end;
    exit;
   end;

END;


FUNCTION Joystick1_Installed;
BEGIN
(* ASM

  mov @result,1
  mov ah,$84
  mov dx,1
  int $15
  or  ax,ax
  jne @ende
  or  bx,bx
  jne @ende
  mov @result,0
 @ende:
    
 END;*)
 JoyStick1_Installed := false;
END;


FUNCTION Joystick2_Installed;
BEGIN
 (*ASM

  mov @result,1
  mov ah,$84
  mov dx,1
  int $15
  or  cx,cx
  jne @ende
  or  dx,dx
  jne @ende
  mov @result,0
 @ende:

 END;*)
 JoyStick2_Installed := false;
END;


PROCEDURE Joystick_Status;
 (*Var status : byte;*)
BEGIN
(*
 if j1 then status:=3 else status:=0;
 if j2 then status:=status or 12;

 ASM

  xor ax,ax
  xor cx,cx
  mov bl,status

  mov ah,1
  mov bh,2
  mov dx,$201

  cli

  out dx,al

 @@joyloop:
  in al,dx

  test al,ah
  jne @@nox1
  test bl,ah
  je  @@nox1
  mov joy.x1,cx
  xor bl,ah
 @@nox1:

  test al,bh
  jne @@noy1
  test bl,bh
  je  @@noy1
  mov joy.y1,cx
  xor bl,bh
 @@noy1:

  test al,4
  jne @@nox2
  test bl,4
  je  @@nox2
  mov joy.x2,cx
  xor bl,4
 @@nox2:

  test al,8
  jne @@noy2
  test bl,8
  je  @@noy2
  mov joy.y2,cx
  xor bl,8
 @@noy2:

  inc cx
  or  bl,bl
  jne @@joyloop

  sti

  mov status,al

 END;

 joy.b1:=(status and 16)=0;
 joy.b2:=(status and 32)=0;
 joy.b3:=(status and 64)=0;
 joy.b4:=(status and 128)=0;
*)
END;



FUNCTION InitMouse;
 (*Var buttons : word;*)
BEGIN
 (*ASM

  xor ax,ax
  int 33h
  or  ax,ax
  jne @@ok
  xor bx,bx
 @@ok:
  mov buttons,bx

 END;

 if (buttons=$ffff) then initmouse:=2 else initmouse:=buttons;*)
 InitMouse := 0; { report no mouse }

END;

PROCEDURE Mouse_Status;
 (*Var Status : word;*)
BEGIN
 (*ASM
  mov ax,03h
  int $33
  mov mouse.x,cx
  mov mouse.y,dx
  mov status,bx
 END;

 mouse.bl:=(status and 1)=1;
 mouse.br:=(status and 2)=2;
 mouse.bm:=(status and 4)=4;*)

END;

PROCEDURE PutMouse;
BEGIN
(*ASM
 mov ax,04h
 mov cx,x
 mov dx,y
 int 33h
END;*)
END;

END.